# Hunter's Infinite Grenades Addon
#  
# Install instructions:
#       1. Install Mattie's EventScripts 2.0 plugin:
#           http://mattie.info/cs/
#
#       2. Copy and upload this script to:
#           <gamedir>/addons/eventscripts/infinite_grenades/
#
#       3. Add the following line somewhere in autoexec.cfg:
#           es_load infinite_grenades
#
################################################################################
#import EventScripts
import es
#import Libraries
import gamethread
import playerlib
#import Psyco Compiler
import psyco
psyco.full()

# Addon Information
info = es.AddonInfo()
info.name = "Infinite Grenades"
info.version = "2.0.0"
info.author = "Hunter"
info.url = "http://addons.eventscripts.com/addons/user/289"
info.description = "Gives you unlimited grenades"
info.basename = "infinite_grenades"

hunter_infinite_grenades_ver    = info.version
hunter_infinite_grenades_text   = 'Hunters '+info.name+', www.sourceplugins.de, '+info.version+', ES 2.0.0.247+ (Python Version)'

# Server Variables
infinite_grenades_hegrenades    = es.ServerVar('infinite_grenades_hegrenades', '1', 'Which grenades should be unlimited?')
infinite_grenades_flashbangs    = es.ServerVar('infinite_grenades_flashbangs', '1', 'Which grenades should be unlimited?')
infinite_grenades_smokegrenades = es.ServerVar('infinite_grenades_smokegrenades', '1', 'Which grenades should be unlimited?')
infinite_grenades_spawn         = es.ServerVar('infinite_grenades_spawn', '1', 'Give grenades on spawn?')
infinite_grenades_rate          = es.ServerVar('infinite_grenades_rate', '3', 'How often should the players be refilled?')

def load():
    public = es.ServerVar('hu_ig', info.version, info.name)
    public.makepublic()
    
    gamethread.delayed(int(infinite_grenades_rate), refill_players)

    es.log(hunter_infinite_grenades_text)
    es.msg('#multi', '#green[InfiniteGrenades] #defaultLoaded')
    
def unload():
    es.msg('#multi', '#green[InfiniteGrenades] #defaultUnloaded') 

def es_client_command(event_var):
    if (str(event_var['command']) == '!hunter_infinite_grenades_ver') or (str(event_var['command']) == '!hunter_all_ver'):
        es.cexec(int(event_var['userid']), 'echo '+hunter_infinite_grenades_text)

def player_activate(event_var):
    gamethread.delayed(30, es.cexec, (int(event_var['userid']), 'echo '+hunter_infinite_grenades_text))

def player_spawn(event_var):
    refill_grenades(int(event_var['userid']))
    
def hegrenade_detonate(event_var):
    refill_hegrenades(int(event_var['userid']))
    
def flashbang_detonate(event_var):
    refill_flashbangs(int(event_var['userid']))

def smokegrenade_detonate(event_var):
    refill_smokegrenades(int(event_var['userid']))

def refill_hegrenades(userid):
    if int(infinite_grenades_hegrenades):
        player = playerlib.getPlayer(userid)
        if not bool(player.get('isdead')):
            grenades = player.get('he')
            if (int(grenades) < 1) and int(infinite_grenades_spawn):
                es.server.cmd('es_xgive '+str(userid)+' weapon_hegrenade')
            player.set('he', '999')
    
def refill_flashbangs(userid):
    if int(infinite_grenades_flashbangs):
        player = playerlib.getPlayer(userid)
        if not bool(player.get('isdead')):
            grenades = player.get('fb')
            if (int(grenades) < 1) and int(infinite_grenades_spawn):
                es.server.cmd('es_xgive '+str(userid)+' weapon_flashbang')
            player.set('fb', '999')

def refill_smokegrenades(userid):
    if int(infinite_grenades_smokegrenades):
        player = playerlib.getPlayer(userid)
        if not bool(player.get('isdead')):
            grenades = player.get('sg')
            if (int(grenades) < 1) and int(infinite_grenades_spawn):
                es.server.cmd('es_xgive '+str(userid)+' weapon_smokegrenade')
            player.set('sg', '999')

def refill_grenades(userid):
    refill_hegrenades(userid)
    refill_flashbangs(userid)
    refill_smokegrenades(userid)

def refill_players():
    gamethread.delayed(int(infinite_grenades_rate), refill_players)
    for userid in es.getUseridList():
        refill_grenades(userid)
